# Kliima-atlas TÜ kliimateaduste keskusele

## Ülevaade
Kliima-atlas (edaspidi atlas), on platform jagamaks infot kliima andmete kohta erinevates ajalistes ja ruumilistes mastaapides ning erinevates visualiseerimise tehnikates (lühitekstid, tabelid, graafikud, kaardid), mis on koondatud eraldiseisvateks n.ö. "töölaudadeks", i.k. dashboard. Atlast iseloomustab kasutamise lihtsus ning konfigureeritavus: iga probleemi jaoks on võimalik luua eraldi lihtne vaade/töölaud, mis just andtud probleemi kõige paremini iseloomustab.

Atlast iseloomustab konfigureeritavus. Kuna ei ole võimalik ette teada, milliseid andmeid täpselt on vaja millisele huvigrupile kuvada näiteks poole aasta pärast, siis peab olema võimalik luua vastav konfiguratsioon lihtsa vaevaga. 

Atlas ei ole esialgu mõeldud teenindama avalikkust, vaid piiratud hulka kasutajaid spetsiifiliste vajadustega. Erinevad kasutajagrupid omakorda võivad vajada ligipääsu erinevatele andmetele, erinevatele selgitavatele materjalidele jne.

Käesoleva atlase kirjelduse osa ei ole andmete ettevalmistuse protsess, st kuidas viiakse mudelite või jaamade mõõtmiste andmed atlasele sobivasse formaati.

## Funktsionaalsed nõuded
* Üksik töölaud peab olema konfigureeritav puhtalt Python programmeerimiskeele vahenditega. Näited sellistest keskkondadest on https://dash.plotly.com/ ,  https://panel.holoviz.org/ ja https://bokeh.org/ . 
* Üksik töölaud peab olema realiseeritav eraldiseisva Docker konteinerina.
* Kasutajakeskkond peab olema sõltumatu, st seda sama lehekülge korduvalt avades ei tohi vaated üksteist segada
* Kasutajakeskkond on "olekuvaba/stateless", st graafikud ainult näitavad andmeid vastavalt tehtud valikutele. 


### Monitoorimine
Tagamaks atlase kasutatavust, on vajalik pidevalt monitoorida süsteemi töökorda ja jõudlust. Monitoorimine võib olla teostatud AWSi vahenditega.

* logidest ülevaate tegemine (http errorid jne)
* kui palju on kasutajad sees käinud
* kui kaua mingi lehekülg laeb
  * iseäranis riskantne on avaleht, kui see laeb liiga kaua, võib jääda mulje mittetöötavast teenusest
  * graafikute laadimine
* kui kaua on ECS kasutuses olnud
* rahaline kulu

## Mittefunktsionaalsed nõuded
* Paigaldus (deployment):
  * Rakendus on realiseeritud docker konteineritena
  * rakendus on kasutatav ja testitav eraldi komponentidena (töölaud, sisselogimise leht jne)
  * rakendus on käivitatav nii arendaja arvutis kui AWS ECS keskkonnas
* rakendus ei ole pidevalt kuum, vaid vastavat töölauda kuvav dockeri konteiner laetakse tööle alles vastava keskkonna aktiveerimisel. 
* Teenus peab vaikimisi olekus olema odav, st ressursside kasutus peab olema minimaalne. Näiteks Lambda + S3 sisselogimise lehe jaoks. 

## Andmete kirjeldus
* Andmete struktuuri tüübid
  * Rasterandmed. Geograafiliste koordinaatidega seotud "pilt", mida saab kuvad kaardil. Näiteks temperatuur Eesti, Tallinna kohal. Andmestik võib olla ühe ajasammuga (pikaajaline keskmine) või sisaldada palju ajasamme (temperatuur igal päeval). 
  * Aegridade andmed. Andmed geograafiliste punktide kaupa: aeg, temperatuur, tuule kiirus, sademete hulk jne
* Andmete katalogiseerimine.
  * Andmete kirjeldus on realiseeritud STAC formaadis (staatilised json fail(id), mis kirjeldab kõik ära)
  * kataloogi uuendamine toimub uute andmete lisandumisel
* Failiformaadid
  * aegread on esitatud (geo)parquet formaadis, mis on kasutatav nii kohalikus keskkonnas kui loetav otse S3'st
  * Rasterandmed esitatakse kas COG (cloud optimised geotiff) GeoTIFF formaadis (eelistatud) või ZARR formaadis.

## Tehnoloogia komponendid
### Tehnoloogia valik. [uuendatud 20.03.2025]
* Eelistatud lahendus on pythoni dashboard, nagu panel või plotly dash. Selline lahendusel on head ja halvad küljed. Esiteks head:
  * Kiire arendusprotsess. Kogu pythoni kood on korraga arendatav ja testitav. Kui arendaja on kursis visuaalsete Notebookide tegemisega Jupyter keskkonnas, on ta võimeline aru saama ka 
  * Ei vaja teadmisi frontendist, Javascript jne
  * Rakendus ei sõltu eraldi backendi teenusest.
  * Rakendus on võimeline toimima erinevate andmestruktuuridega ja ei vaja alati eraldi andmete ette valmistamist. AWS pilves asuv rakendus saab töötada geoandmefailidega otse S3'st, mis vähendab andmete lugemisele kuluvat aega. 
* Halvad küljed.
	* Lahendus on ressursinõudlik. Töö sujuvuse tagamiseks on vajalik igale kasutajale eraldi ressursi leidmine.
  

Esialgne eelistuste järjekord.

## Kasutajalood
* Üldistatud kasutajalugu
![üldistatud kasutaja](./Kasutamine-Kasutaja.png)

* Kasutaja: KOV ametnik
  * Liikudes avalehele, näeb kasutaja sisselogimisakent (kas individuaalkasutaja või asutuse kaupa)
  * parooli sisestamise järel näeb kasutaja laadimislehte, mis kuvab vastavat keskkonda pakkuva teenuse olekut (seisab, laeb, rikkis, valmis). 
  * kui konteiner käib, saab kasutaja vaadata interaktiivseid graafikuid, valida parameetreid, zoomida kaarti sisse-välja jne.

